

%% a toy dataset
a=dataset([1 6; 3 9; 4 1; 6 5; 7 8; 8 6; 10 2; 12 8],genlab([5 3]))

%% show it
scatterd(a),axis([0 14 0 10])

%% its voronoi diagram
voronoi(+a(:,1),+a(:,2))

%%  delaunay triangulation
 tri=delaunay(+a(:,1),+a(:,2));
 triplot(tri,+a(:,1),+a(:,2));
 pause

 %% show kNN decision boundaries
 scatterd(a),axis([0 14 0 10])
 plotc(  {knnc(a,1);knnc(a,3);knnc(a,6)} )
 
pause 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% a Small 2-class gaussian dataset
N=50; 
mA=[2 2];
mB=[4 3];
labs=[1 2]';
priors=[.5 .5];
GA = [.4 0; 0 3];    GB = [.5 0; 0 .5];
covs=cat(3,GA,GB);

U = dataset([mA ; mB],labs,'prior',priors)
A = gauss(N, U, covs)
scatterd(A)

wb = nbayesc(U,covs);

%% show kNN decision boundaries and Bayes ones
plotc(  {knnc(A,1);knnc(A,3);knnc(A,6);wb} )

pause
%%%%%%%%%%%%%%%%%%%%%%%%
%% A large 2-class gaussian dataset
N=1000; 
mA=[0 0];
mB=[4 0];
labs=[1 2]';
priors=[.5 .5];
GA = [.5 0; 0 .5];    GB = [2 0; 0 2];
covs=cat(3,GA,GB);

U = dataset([mA ; mB],labs,'prior',priors)
A = gauss(N, U, covs)
scatterd(A)

pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Show the effect of increasing k
W=[]; %set of classfs
E=[]; %errors
kas=1:3:41
for k=kas
    wk = knnc(A,k);
    W = [ W wk ];
    E = [ E testc(A*wk) ];
    end
    
figure(2),clf,plot(kas,E);  
xlabel('no. of neighbors (k)');
ylabel('error rate');
title('Training set (resubsitution)')


pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
B = gauss(N, U, covs)
W=[]; %set of classfs
E=[]; %errors
%kas=1:3:41
for k=kas
    wk = knnc(A,k);
    W = [ W wk ];
    E = [ E testc(B*wk) ];
    end
    
figure(2),hold on, plot(kas,E,'rx-');    
%xlabel('no. of neighbors (k)');
%ylabel('error rate');
legend({'Train';'Test'})
title('Training and Test set')


pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

E   %% show errors

testc(B*nbayesc(U,covs))  %% show Bayes rate
%%%%%%%%%%%%%%%%%%%%%%%%%%%
testc( gauss(N, U, covs)*nbayesc(U,covs) ) 

hold on,plot(4,testc( gauss(N, U, covs)*nbayesc(U,covs) ),'*')
legend({'Train';'Test';'Bayes'})

pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% A 2-class gaussian dataset
close all
N=1000; 
mA=[0 0];
mB=[4 0];
labs=[1 2]';
priors=[.5 .5];
GA = [1.5 0; 0 1];    GB = [2 0; 0 2];
covs=cat(3,GA,GB);

U = dataset([mA ; mB],labs,'prior',priors)
A = gauss(N, U, covs)
figure(1),scatterd(A)

wb=nbayesc(U,covs);
plotc(wb)

%% assigned labels
LA=labeld(A*wb);
%% real labels
LR=getnlab(A);
%% correctly classified
figure(2),clf,scatterd(A(LA==LR,:))
plotc(wb)
xx=axis

figure(3),scatterd(A(LA~=LR,:))
axis(xx)
plotc(wb)


%% 1-NN using the "edited" set
figure(2), plotc( knnc(A(LA==LR,:),1)  ,2)
title('Ideal edited 1-NN rule')

%% the edited set
%%figure(2),scatterd(A(LA==LR,:))

%% real editing

k=11
Aedi = A( labeld(A*knnc(A,k))==getnlab(A) ,:)

figure(5),clf, scatterd(Aedi)
plotc( knnc(Aedi,1) , 2);
title('Real (k=11) edited 1-NN rule')


%% Repeated editing
figure(6)
Aedi=A;
k=3;
for i=1:7
    
    Aedi = Aedi( labeld(Aedi*knnc(Aedi,k))==getnlab(Aedi) ,:)
    figure(6), scatterd(Aedi),plotc( knnc(Aedi,1) , 2);
end

pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%identifying outliers

Res=A*wb;
LR=getnlab(A);
mm = [ max(+Res(:,1)) max(+Res(:,2)) ];
t = 0.3 * mm;

figure(7),scatterd(A( +Res(:,1)>t(1)&LR==1 | +Res(:,2)>t(2)&LR==2    , :))



